﻿Public Class PersonDataManager
    Implements IPersonDataManager

    Private CachedPersonList As List(Of Person)
    Public Function GetAviablePersons(includeDeleted As Boolean, Optional reload As Boolean = False) As ICollection(Of Person) Implements IPersonDataManager.GetAviablePersons
        'In diesem Beispiel geben wir mal irgendwelche Datan zurück
        If CachedPersonList Is Nothing Then CachedPersonList = New List(Of Person) : reload = True
        If reload Then
            CachedPersonList.Clear()
            For i As Integer = 0 To 9
                Dim newPerson = New Person() With {.Name = $"Name {i.ToString()}", .Age = GenerateRandomNumber(18, 80)}
                If i Mod 2 = 0 Then newPerson.IsDeleted = True 'zum probieren jeden zweiten Eintrag als gelöscht markieren
                CachedPersonList.Add(newPerson)
            Next
        End If
        If includeDeleted Then
            Return CachedPersonList
        Else
            Return CachedPersonList.Where(Function(x) Not x.IsDeleted).ToList()
        End If
    End Function

    Public Function SaveChanges(person As Person) As Boolean Implements IPersonDataManager.SaveChanges
        'Wir speichern ja nicht wirklich aber wir ersetzen das Objekt
        Dim pEntry = CachedPersonList.Where(Function(x) x.Name = person.Name).Single()
        pEntry.Name = person.Name
        pEntry.Age = person.Age
        pEntry.IsDeleted = person.IsDeleted
        Return True
    End Function

    Function GenerateRandomNumber(min As Integer, max As Integer) As Integer
        Static Random_Number As New Random()
        Return Random_Number.Next(min, max)
    End Function
End Class
