﻿
Imports BindigTest.ViewModel.Infrastructure

Namespace ViewModel
    Public Class PersonViewModel
        Inherits ViewModelBase

        Friend modelObject As Person

        Public Sub New()
            modelObject = New Person()
            If IsInDesignMode Then
                With modelObject
                    .Name = "Max Mustermann"
                    .Age = 18
                End With
            End If
        End Sub
        Public Sub New(person As Person)
            modelObject = person
        End Sub

        Public Property Name() As String
            Get
                Return modelObject.Name
            End Get
            Set(ByVal value As String)
                modelObject.Name = value
                RaisePropertyChanged()
                RaisePropertyChanged(NameOf(SamName))
            End Set
        End Property

        Public Property Age() As Integer
            Get
                Return modelObject.Age
            End Get
            Set(ByVal value As Integer)
                modelObject.Age = value
                RaisePropertyChanged()
                RaisePropertyChanged(NameOf(SamName))
            End Set
        End Property

        Public Property IsDeleted As Boolean
            Get
                Return modelObject.IsDeleted
            End Get
            Set
                modelObject.IsDeleted = Value
                RaisePropertyChanged()
            End Set
        End Property

        Public ReadOnly Property SamName() As String
            Get
                Return $"{Name}.{Age}"
            End Get
        End Property

    End Class
End Namespace